// MOD of:
// CustomVoice.cs ver 2.2  4-15-01 - written by Govt.Cheese[D6]
// Moddified by TracerDX
// 
// This file makes the Voicepack support and Custum Voice Pack autoload
// at the end of all other script inits. This is done because the 
// functions supercede some of the existing tribes2 ones.
// To use this functionality see the accompying Make_Your_Own File.
//
// From TracerDX:
// I tried everything I knew under the damned sun get my scripts to work along side this damned thing,
// but the author wrote this script like no one else in the world ever wanted to access to these functions.
// So it boils down to me having to include this MOD/Override version.
//
// Basically its a near copy of the author's original work, but with a few calls to my functions for
// event processing. It uses the same stuff as the original, so VoicePack.cs is incompatible with my script

//--------DO NOT EDIT BELOW THIS LINE----------
// DO NOT EDIT THIS FILE!!

echo("\c4VoicePack Over-ride engaged);

//Init the global table and the counter to 0 at script run
$VoicePackCount = 0; //no packs registered
$voicePackTable[0] = ""; //The global table of Voices Built
$voicePackChangedActive = 0; //Gets set to 1 if we change in the gui
$VoicePackInit = 0; //Detects if the list has been built yet

deactivatePackage(CustomVoicePackageOverRide);
package CustomVoicePackageOverRide {

function DispatchLaunchMode() 
{
	// Create our Gui object before things get run
	VoicePackMenuCreate();
	parent::DispatchLaunchMode();

	//Check for PJ's Super Chat
	checkForPJSuperChat();
}

// This function will create the gui objects, independent of a hierarchy, that we
// want to add to the GameGui. 
function VoicePackMenuCreate()
{
	if(strstr($pref::video::resolution, "640")!=-1) {
		echo("Running at 640 mode...");
		%pos1 = "9 40";
		%pos2 = "125 31";
	} else {
		%pos1 = "270 12";
		%pos2 = "380 3";
		}
	new GuiTextCtrl(VoicePackText) {
		profile = "ShellTextRightProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %pos1;
		extent = "115 22";
		minExtent = "8 8";
		visible = "1";
		helpTag = "0";
		text = "Custom Voice Pack:";
		maxLength = "255";
		};
	new ShellPopupMenu(VoicePackPopup) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %pos2;
		extent = "150 38";
		minExtent = "49 36";
		visible = "1";
		helpTag = "0";
		text = "Select Voice";
		maxLength = "30";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
		};
//The trick to using them without redoing the whole GameGui.cs file is the find the 
// gui object the parents that place that you want to put them and then gets its name
// and do itsname.add(yourobj) . This will create a new object that is a child to them
// and place it on the page automagically! IF you need to install or do things use the 
// parents properties to do them.
	GM_WarriorPane.add(VoicePackText);
	GM_WarriorPane.add(VoicePackPopup);
}

//This function is the parent to our gui objects and we activate our stuff when the
//onActivate gets called, don't forget to parent::onActivate at the end or everything
//goes to hell.
function GM_WarriorPane::onActivate( %this )
{
	VoicePackPopup.clear();
	echo("Starting VoicePack Menu Build...Have "@$VoicePackCount@" Voice Packs Registered");
	for(%i=0; %i < $VoicePackCount; %i++) {
		VoicePackPopup.add( $voicePackTable[%i],%i);
		echo("Adding "@$voicePackTable[%i]@" to the list of VoicePacks installed");
	}
	// Need to check and see if defaultVoicePack exists, if not, set it to,
	//   otherwise, if they don't click on the pack name, nothing will load.
	if($pref::Audio::defaultVoicePack $="")
		$pref::Audio::defaultVoicePack = 0;
	VoicePackPopup.setSelected($pref::Audio::defaultVoicePack); //Sets the active
	//element in a drop down list.
	parent::onActivate(%this);//For a multiple down function like set1::sub1 you just
	//use the last listed on the parent.
}

function VoicePackPopup::onAdd( %this )
{
	//this is here to keep the compiler from complaing
}

//function that gets called when a drop down menu item is clicked.
function VoicePackPopup::onSelect(%this, %id, %text)
{
	$voicePackChangedActive=1; //We changed an option here, need to rebuild menu.
	$pref::Audio::defaultVoicePack=%id; //Reset the global thing
	//echo("Pack changed... Active Pack:"@$pref::Audio::defaultVoicePack@" Text: "@%text);
}

//This function actaully loads the callers script to put things on the voice
//menu. It uses the id given as the pack preface.
function VoicePackActivate()
{
 //If we have been in a game or done this several times, we need to clear the global
 //chat menu, this done with activate and the default voiceBinds.cs file
	echo("Starting VoicePack Build...");
	if($voicePackChangedActive==1) {
		echo("Changed seclection, rebuilding base menu.");
		activateChatMenu("scripts/voiceBinds.cs");
		$VoicePackInit = 0;
		$voicePackChangedActive=0;
	}
	if($VoicePackInit == 0) {
		$VoicePackInit = 1;
		%scriptname = "scripts/" @ $voicePackTable[$pref::Audio::defaultVoicePack] @ "VoicePack.cs";
		echo("Pack Selected to Exec: "@%scriptname);
		exec(%scriptname);
	}
}
//Redone function to load the chat menu
function StartHostedGame()
{
	VoicePackActivate();
	parent::StartHostedGame();
}

function JoinGame(%address)
{
	VoicePackActivate();
	parent::JoinGame(%address);
}

//This function is called by the user/customvoicepack and will register the name
// and increment the number of total packs.
function VoicePackRegisterName(%name)
{
	$voicePackTable[$voicePackCount] = %name;
	$VoicePackCount++;
	echo("Voice Pack Registered: "@ $voicePackTable[$voicePackCount-1]);
	echo("Total Voice Packs Now: "@ $VoicePackCount); 
}

//implement later.
//function testChatCommand( %command )
//{
//	if ( $pref::Player::Count > 0 )
//    		%voiceSet = getField( $pref::Player[$pref::Player::Current], 3 );
//	else
//		%voiceSet = "Male1";
//	ChatCommandTestBtn.setActive( false );
//	if(
//		%wav = "voice/" @ %voiceSet @ "/" @ $ChatTable[%command].audioFile @ ".wav";   
//}

function issueChatCmd( %menu, %index )
{
	// We need to pull the message from the list that was created at the beggining.
	// This is done with the method below, it pulls out the entire string including
	// the voice name with its delimeter
	%command = %menu.command[%index];
	%cmdCode = getWord( %command, 0 );
	%cmdId = getSubStr( %cmdCode, 1, strlen( %command ) - 1 );
	%cmdString = getWord( %command, 1 );
	%chatItem = $ChatTable[%cmdId];
	%message = %chatItem.text @ "~w" @ %chatItem.audioFile; //construct the full message

	// At this point, we check if it is a local sound by looking for the K at the
	// beggining of the filename - this signals our delimeter. ~w is the default 
	// delim for a voice message and we add a K to that so it fools the system into
	// working. But, if we find a custom voice here, we need to use a different method
	// to send to the server and other clients than the default commandToServer(cannedChat,)
	// if cannedChat is sent, the server will auth against its list of voices and reget any 
	// that we send with non normal Bindnames.
	if(strstr(%message, "~wK") !=-1)
		if ( %chatItem.teamOnly ) {
			commandToServer('teamMessageSent', %message, false);
			cancelChatMenu(); //Close chat menu 
		} else {
			commandToServer('messageSent', %message, false);
			cancelChatMenu(); //Close chat menu
		}
	else
		parent::issueChatCmd(%menu, %index);
	// Otherwise send it via the normal method of cannedChat, which auths with the server
	// to make sure that voice sent exists on the server - This BAD! 
} //End of issueChatCmd()


function clientCmdChatMessage(%sender, %voice, %pitch, %msgString1, %playerName, %msgString2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
{
 	//echo("clientCmdChatMessage('" @ %sender @ "', '" @ %voice @ "', '" @ %pitch @ "', '" @ %msgString1 @ "', '" @ %playerName @ "', '" @ %msgString2  @ "', '" @ %a3 @ "', '" @ %a4 @ "', '" @ %a5 @ "', '" @ %a6 @ "', '" @ %a7 @ "', '" @ %a8 @ "', '" @ %a9 @ "', '" @ %a10 @ "')");

	//Get rid of number tag if sent with one
	%message = detag( %msgString1 ); $MaxMessageWavLength = 120000; //2 Minutes is the max wav time now... That's way more than enough
	
	//echo("\c4Recived Voice Bind Message: '" @ %message @ "'");

	%wavStart = strpos(%message,"~w");

	echo("%voice = " @ %voice);

	//If Null Voice Message was filtered, "un-filter"
	if (detag(%voice) $= "")
		if (strpos(%msgString1, ".wav") == -1)
			%msgString1 = %msgString1 @ ".wav";
		
		

	//Ignore Messages from self
	//if ( detag( %playerName ) !$= getManagerName()) {
		 
		//Get rid of default Key sequence if CannedChat
		if (getSubStr(%message, 0, 1) $= "[")
			%eventMessage = getSubStr(%message, (strpos(%message, "]") + 1), strlen(%message));
		else
			%eventMessage = %message;

		//Get Player name and remove from string
		%eventPlayer = getSubStr(%eventMessage, 0, (strpos(%eventMessage, ":")));
		%eventMessage = getSubStr(%eventMessage, (strpos(%eventMessage, ":") + 1), strlen(%eventMessage));
		
		//Split Text from sound
		if ( %wavStart != -1) {
			//echo("TRUE");
			%eventSound = getSubStr(%eventMessage, (%wavStart + 2), strlen(%eventMessage));
			%eventMessage = getSubStr(%eventMessage, 0, %wavStart);
		}

		//Send event to event processor
		if (isFile("scripts/autoexec/TDXEventManager.cs"))
			processTDXEvent("TALK", detag(%playerName), %eventMessage, %eventSound);

	//}

	if( (%message $= "" ) || isClientChatMuted(%sender) )
		return;
	if ( %wavStart == -1 )
		addMessageHudLine(%message);
	else
		if(strstr(%message, "~wK") !=-1) {
			
			%voice = "custom"; //Assign our base directory here.
			%wav = getSubStr(%message, %wavStart + 3, 1000); //Move the name three spaces for our delim
			%wavFile = "voice/" @ %voice @ "/" @ %wav @ ".wav";
			if (%pitch < 0.5 || %pitch > 2.0)
				%pitch = 1.0;
			%wavLengthMS = alxGetWaveLen(%wavFile) * %pitch;
			if ( $ClientChatHandle[%sender] != 0 )
				alxStop( $ClientChatHandle[%sender] );
			$ClientChatHandle[%sender] = alxCreateSource( AudioChat, %wavFile );
			if (%pitch != 1.0)
				alxSourcef($ClientChatHandle[%sender], "AL_PITCH", %pitch);
			alxPlay( $ClientChatHandle[%sender] );
			%message = getSubStr(%message, 0, %wavStart);
			addMessageHudLine(%message);
		} else
			parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString1, %playerName,  %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
			// Call back using the parent process to handle it if we don't have custom sound.
}



};
activatePackage(CustomVoicePackageOverRide);

function checkForPJSuperChat() {
	// Gotta make sure user doesn't have version of PJ's that blocks sounds...
	
	if (($PJVersion::SuperChat $= "7.03") || ($PJVersion::SuperChat $= "7.02") || ($PJVersion::SuperChat $= "7.01")) {
		echo("\c4TDXChat: PJ's SuperChat Patched");
		activatePackage(TDXSuperChatFix);
	}

	if (isFile("scripts/autoexec/VoicePack.cs"))
		MessageBoxOK( "VOICEPACK.CS", "TracerDXChat REPLACES VoicePack.vl2 in your Base Dir. If you do not remove this file, TDXChat will NOT function correctly!");



}

package TDXSuperChatFix {

	function PJclientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10) {

		if($PJEnable::SuperChat == 1) {

			%message = detag( %msgString );

			if($PJPref::SuperFlood) {
				if(SuperFloodProtect(detag(%sender), %msgString) $= "Mute")
					return -1;
				}

			if ( ( %message $= "" ) || isClientChatMuted( %sender ) )
				return -1;

			if(PlayGui.isAwake() && $HudMode !$= "Observer") {

				// search for wav tag marker
				%wavStart = strstr( %message, "~w" );
				if ( %wavStart == -1 ) {
	//echo("1: "@ %message);
					if(StrStr(%message,"\c3") != -1 ) {
						if($PJPref::TeamChatFriendly) {
							addFriendlyChatLine( %message );
							%msgString = "";
							if($PJPref::PopupTeamChat)
								TeamHudShow();
						} else {
							addMessageHudLine( %message );
							%msgString = "";
						}
					} else {
							 if(!$PJPref::MuteEnemyTeam){
     						if($PJPref::TeamChatEnemy) {
     							addGlobalChatLine( %message );
     							%msgString = "";
     							if($PJPref::PopupGlobalChat)
     								GlobalHudShow();
     						} else {
     							addMessageHudLine( %message );
     							%msgString = "";
								  }
						} else %msgString = "";
					}
				} else {

					if(strstr(%message, "~wK") !=-1) {
						if($PJPref::MuteD6Message == 1)
							return -1;
						%voice = "custom"; //Assign our base directory here.
						%wav = getSubStr(%message, %wavStart + 3, 1000); //Move the name three spaces for our delim
					} else {
						%wav = getSubStr(%message, %wavStart + 2, 1000);
					}
	//echo("1: "@ %message);
	//echo("2: "@ %wav @ " " @strlen(%wav));
					if($odysseyACSmute[%wav] == 1) {
						echo("Muted Odyssey message: "@%wav);
						return -1;
					}

					if (detag(%voice) !$= "")
						%wavFile = "voice/" @ detag(%voice) @ "/" @ %wav @ ".wav";
					else
						%wavFile = %wav;

					//only play voice files that are < 5000ms in length
					if (%pitch < 0.5 || %pitch > 2.0)
						%pitch = 1.0;

					%wavLengthMS = alxGetWaveLen(%wavFile) * %pitch;
					if (%wavLengthMS < $MaxMessageWavLength ) {
						if ( $ClientChatHandle[%sender] != 0 )
							alxStop( $ClientChatHandle[%sender] );

						$ClientChatHandle[%sender] = alxCreateSource( AudioChat, %wavFile );

					//pitch the handle
					if (%pitch != 1.0)
						alxSourcef($ClientChatHandle[%sender], "AL_PITCH", %pitch);

					alxPlay( $ClientChatHandle[%sender] );
					} else error( "** WAV file \"" @ %wavFile @ "\" is too long! **" );

					%message = getSubStr(%message, 0, %wavStart);

					if(StrStr(%message,"\c3") != -1) {
						if($PJPref::TeamChatFriendly) {
							addFriendlyChatLine( %message );
							%msgString = "";
							if($PJPref::PopupTeamChat)
								TeamHudShow();
						} else {
							addMessageHudLine( %message );
							%msgString = "";
						}
					} else {
							 if(!$PJPref::MuteEnemyTeam){
     						if($PJPref::TeamChatEnemy) {
     							addGlobalChatLine( %message );
     							%msgString = "";
     							if($PJPref::PopupGlobalChat)
     								GlobalHudShow();
     						} else {
     							addMessageHudLine( %message );
     							%msgString = "";
     						}
						} else %msgString = "";
					}
				}
			}
		}

		 return %msgString;
	}

};

