//**************************************************************
// Cheetah ASSAULT VEHICLE
//**************************************************************
//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock HoverVehicleData(CheetahVehicle) : TankDamageProfile
{
   spawnOffset = "0 0 4";

   floatingGravMag = 4.5;

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_tank.dts";
   multipassenger = true;
   computeCRC = true;
   renderWhenDestroyed = false;
                                                 
   weaponNode = 1;

   debrisShapeName = "vehicle_land_assault_debris.dts";
   debris = ShapeDebris;

   drag = 0.0;
   density = 0.9;

   mountPose[0] = sitting;
   mountPose[1] = sitting;
   numMountPoints = 2;
   isProtectedMountPoint[0] = true;
   isProtectedMountPoint[1] = true;

   cameraMaxDist = 20;
   cameraOffset = 3;
   cameraLag = 1.5;
   explosion = LargeGroundVehicleExplosion;
   explosionDamage = 0.5;
   explosionRadius = 5.0;

   maxSteeringAngle = 0.5;  // 20 deg.

   maxDamage = 3.00;
   destroyedLevel = 3.00;

   isShielded = true;
   rechargeRate = 1.0;
   energyPerDamagePoint = 150;
   maxEnergy = 400;
   minJetEnergy = 15;
   jetEnergyDrain = 2.0;

   // Rigid Body
   mass = 1500;
   bodyFriction = 0.8;
   bodyRestitution = 0.5;
   minRollSpeed = 3;
   gyroForce = 400;
   gyroDamping = 0.3;
   stabilizerForce = 20;
   minDrag = 10;
   softImpactSpeed = 15;      // Play SoftImpact Sound
   hardImpactSpeed = 30;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 28;
   speedDamageScale = 0.040;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 20;
   collDamageMultiplier   = 0.045;

   dragForce            = 40 / 20;
   vertFactor           = 0.0;
   floatingThrustFactor = 0.25;

   mainThrustForce    = 75;
   reverseThrustForce = 50;
   strafeThrustForce  = 50;
   turboFactor        = 1.8;

   brakingForce = 25;
   brakingActivationSpeed = 4;

   stabLenMin = 3.25;
   stabLenMax = 4;
   stabSpringConstant  = 60;
   stabDampingConstant = 20;

   gyroDrag = 20;
   normalForce = 20;
   restorativeForce = 20;
   steeringForce = 20;
   rollForce  = 5;
   pitchForce = 3;

   dustEmitter = TankDustEmitter;
   triggerDustHeight = 3.5;
   dustHeight = 1.0;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 3.6;
   dustTrailFreqMod = 15.0;

   jetSound         = AssaultVehicleThrustSound;
   engineSound      = AssaultVehicleEngineSound;
   floatSound       = AssaultVehicleSkid;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   wheelImpactSound = WheelImpactSound;

   forwardJetEmitter = TankJetEmitter;
   
   //
   softSplashSoundVelocity = 5.0; 
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 15.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound; 

   minMountDist = 4;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 3.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDGroundTankIcon;
   cmdMiniIconName = "commander/MiniIcons/com_tank_grey";
   targetNameTag = 'Cheetah';
   targetTypeTag = 'Assault Tank';
   sensorData = VehiclePulseSensor;
   
   checkRadius = 5.5535;
   observeParameters = "1 10 10";
   runningLight[0] = TankLight1;
   runningLight[1] = TankLight2;
   runningLight[2] = TankLight3;
   runningLight[3] = TankLight4;
   shieldEffectScale = "0.9 1.0 0.6";
   showPilotInfo = 1;
};


//*** WEAPON ****

datablock TurretImageData(CheetahChainBarrel)
{
//   shapeFile = "turret_missile_large.dts";
   shapeFile = "weapon_chaingun.dts";
   offset = "-0.04 -0.1 0.2";
   item      = ChainBarrelLargePack;

   projectile = ChainBarrelBullet;
   projectileType = TracerProjectile;

   useCapacitor = true;
   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 6;
   minEnergy = 6;
   emap = true;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 30.0;
   shellVelocity       = 6.0;

   projectileSpread = 5.0 / 1000.0;



   // Turret parameters
   activationMS      = 700;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 300;
   degPerSecPhi      = 500;
   attackRadius      = 95;



   //--------------------------------------
   stateName[0]                  = "Activate";
   stateSequence[0]              = "Activate";
   stateSound[0]                 = ChainBarrelSwitchSound;
   stateAllowImageChange[0]      = false;
   stateTimeoutValue[0]          = 0.6;
   stateTransitionOnTimeout[0]   = "Ready";
   stateTransitionOnNoAmmo[0]    = "NoAmmo";
   stateTransitionOnNotLoaded[0] = "Dead";

   //--------------------------------------
   stateName[1]                    = "Ready";
   stateSpinThread[1]              = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   stateTransitionOnNotLoaded[0]   = "Deactivate";

   //--------------------------------------
   stateName[2]                    = "NoAmmo";
   stateTransitionOnAmmo[2]        = "Ready";
   stateSpinThread[2]              = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   stateTransitionOnNotLoaded[2]   = "Deactivate";

   //--------------------------------------
   stateName[3]                  = "Spinup";
   stateSpinThread[3]            = SpinUp;
//   stateSound[3]                 = ChaingunSpinupSound;
   stateTimeoutValue[3]          = 0.05;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";

   //--------------------------------------
   stateName[4]                  = "Fire";
   stateSequence[4]              = "Fire";
   stateSequenceRandomFlash[4]   = true;
   stateSpinThread[4]            = FullSpeed;
   stateSound[4]                 = ChaingunFireSound;
   stateAllowImageChange[4]      = false;
   stateRecoil[4]                = LightRecoil;
   stateScript[4]                = "onFire";
   stateFire[4]                  = true;
   stateEjectShell[4]            = true;
   stateTimeoutValue[4]          = 0.10;
   stateTransitionOnTimeout[4]   = "Fire";
   stateTransitionOnTriggerUp[4] = "Spindown";
   stateTransitionOnNoAmmo[4]    = "EmptySpindown";

   //--------------------------------------
   stateName[5]                    = "Spindown";
//   stateSound[5]                   = ChaingunSpinDownSound;
   stateSpinThread[5]              = SpinDown;
   stateTimeoutValue[5]            = 0.05;
   stateWaitForTimeout[5]          = true;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Fire";

   //--------------------------------------
   stateName[6]                = "EmptySpindown";
   stateSound[6]               = ChaingunSpinDownSound;
   stateSpinThread[6]          = SpinDown;
   stateTimeoutValue[6]        = 1.0;
   stateTransitionOnTimeout[6] = "NoAmmo";
   
   //--------------------------------------
   stateName[7]                = "DryFire";
   stateSound[7]               = ChaingunDryFireSound;
   stateTimeoutValue[7]        = 0.2;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8]                = "Deactivate";
   stateSequence[8]            = "Activate";
   stateDirection[8]           = false;
   stateTimeoutValue[8]        = 0.5;
   stateTransitionOnLoaded[8]  = "Ready";
   stateTransitionOnTimeout[8] = "Dead";

   stateName[9]               = "Dead";
   stateTransitionOnLoaded[9] = "Ready";


   // State transitions
//   stateName[0]                  = "Activate";
//   stateTransitionOnNotLoaded[0] = "Dead";
//   stateTransitionOnLoaded[0]    = "ActivateReady";
//
//   stateName[1]                  = "ActivateReady";
//   stateSequence[1]              = "Activate";
//   stateSound[1]                 = ChainBarrelSwitchSound;
//   stateTimeoutValue[1]          = 1;
//   stateTransitionOnTimeout[1]   = "Ready";
//   stateTransitionOnNotLoaded[1] = "Deactivate";
//   stateTransitionOnNoAmmo[1]    = "NoAmmo";
//
//   stateName[2]                    = "Ready";
//   stateTransitionOnNotLoaded[2]   = "Deactivate";
//   stateTransitionOnTriggerDown[2] = "Fire";
//   stateTransitionOnNoAmmo[2]      = "NoAmmo";
//
//   stateName[3]                = "Fire";
//   stateTransitionOnTimeout[3] = "Reload";
//   stateTimeoutValue[3]        = 0.07;
//   stateFire[3]                = true;
//   stateRecoil[3]              = LightRecoil;
//   stateAllowImageChange[3]    = false;
//   stateSequence[3]            = "Fire";
//   stateSound[3]               = ChainBarrelFireSound;
//   stateScript[3]              = "onFire";
//
//   stateName[4]                  = "Reload";
//   stateTimeoutValue[4]          = 0.03;
//   stateAllowImageChange[4]      = false;
//   stateSequence[4]              = "Reload";
//   stateTransitionOnTimeout[4]   = "Ready";
//   stateTransitionOnNotLoaded[4] = "Deactivate";
//   stateTransitionOnNoAmmo[4]    = "NoAmmo";
//
//   stateName[5]                = "Deactivate";
//   stateSequence[5]            = "Activate";
//   stateDirection[5]           = false;
//   stateTimeoutValue[5]        = 1;
//   stateTransitionOnLoaded[5]  = "ActivateReady";
//   stateTransitionOnTimeout[5] = "Dead";
//
//   stateName[6]               = "Dead";
//   stateTransitionOnLoaded[6] = "ActivateReady";
//
//   stateName[7]             = "NoAmmo";
//   stateTransitionOnAmmo[7] = "Reload";
//   stateSequence[7]         = "NoAmmo";
};







//*** FUNCTIONS ***


function CheetahVehicle::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   
   %turret = TurretData::create(AssaultPlasmaTurret);
   %turret.selectedWeapon = 1;
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(AssaultPlasmaTurretBarrel, 2);
   %turret.mountImage(CheetahChainBarrel, 4);
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %obj.turretObject = %turret;
   
   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);
   
   //Needed so we can set the turret parameters..
   %turret.mountImage(AssaultTurretParam, 0);
   %obj.schedule(6000, "playThread", $ActivateThread, "activate");

   // set the turret's target info
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
}

function CheetahVehicle::onDamage(%this, %obj)
{
   if(isObject(%obj.getMountNodeObject(10)))
      (%obj.getMountNodeObject(10)).setDamagelevel(%obj.getDamageLevel());
   Parent::onDamage(%this, %obj);
}

function CheetahVehicle::deleteAllMounted(%data, %obj)
{
   %turret = %obj.getMountNodeObject(10);
   if(!%turret)
      return;

   if(%client = %turret.getControllingClient())
   {
      %client.player.setControlObject(%client.player);
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);   
      %client.player.mountVehicle = false;
   }
   %turret.delete();
}

function CheetahVehicle::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0) {
      // driver position
      // is there someone manning the turret?
      //%turreteer = %obj.getMountedNodeObject(1);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
   }
   else if(%node == 1)
   {
      // turreteer position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;   
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      %turret.turreteer = %player;
      // if the player is the turreteer, show vehicle's weapon icons
      //commandToClient(%player.client, 'showVehicleWeapons', %data.getName());
      //%player.client.setVWeaponsHudActive(1); // plasma turret icon (default)
      
      $aWeaponActive = 0;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
      %obj.getMountNodeObject(10).selectedWeapon = 1;
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
   }

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);
}
